package xyz.etztech.commandlistener;

import org.bukkit.Bukkit;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.plugin.java.JavaPlugin;
import xyz.etztech.commandlistener.command.CommandMain;

import java.util.ArrayList;
import java.util.List;
import java.util.logging.Logger;

public class CommandListener extends JavaPlugin {

    private static CommandListener instance;

    public static FileConfiguration config;
    private Logger log = Logger.getLogger( "Minecraft" );
    private List<String> hookCommands = new ArrayList<>();



    @Override
    public void onEnable() {

        instance = this;
        saveDefaultConfig();
        loadConfig();

        if (isEnabled()) {
            CommandMain cmdMain = new CommandMain(this);
            this.getCommand("commandlistener").setExecutor(cmdMain);
            cmdMain.startThread();
            Bukkit.getConsoleSender().sendMessage("Command Listener has started successfully.");
        }
    }

    @Override
    public void onDisable() {

    }

    public void loadConfig() {
        config = Bukkit.getPluginManager().getPlugin("CommandListener").getConfig();
    }

    @Override
    public void reloadConfig() {
        super.reloadConfig();
        loadConfig();
    }



    public void log(String message) {
        log.info( "[CommandListener]: " + message );
    }

}

